/********************************************************
*							*
*	hand held computer communication adapter	*
*							*
*		common subroutine	('87/04/24)	*
*							*
********************************************************/

#include	"adaputer.h"
#include	"adioport.h"
#include	"adcode.h"
#include	"adresp.h"

extern	char	wr_sa[], wr_sb[], rr_sa, rr_sb;
extern	char	*sdptr1, *sdptr2, cmdflg, crcflg;
extern	char	cmdbuf[], rbuff1[], *sdtp, crcf, dipsw;
extern	int	timer0, timer1, timer2, blklng, rrptr1, rdlen1;
extern	int	sdcount1, sdcount2, sdr_lng;
extern	char	sd_flag1, sd_flag2;

static	char	syn_code;

/*	initialize	*/

init()
{
	void	ctc_init();
	void	sio_init();

	outp(P_PMC,(char)0x9a);			/* 8255 initialize	*/

	ctc_init();				/* CTC initialize	*/

	sio_init();				/* SIO initialize	*/

	blklng = 128;
}

/*	CTC initialize	*/

ctc_init()
{
	outp(P_C0C,0x45);
	outp(P_C0C,0x10);
	outp(P_C0C,0x50);	/* interrupt lower table address	*/
	outp(P_C1C,0x03);
	outp(P_C2C,0x03);
	outp(P_C3C,0xa5);
	outp(P_C3C,0xc0);
}

/*	SIO initialize	*/

sio_init()
{
/*
	static	char	id_sioa[] = {	/* A chanel initial data	*/
		0x18,0x13,0x00,0xda,0x10,0x65,0x32,0x32};
*/
	static	char	id_sioa[] = {	/* A chanel initial data	*/
		0x18,0x13,0x00,0xd0,0x10,0x64,0x32,0x32};

	static	char	id_siob[] = {	/* B chanel initial data	*/
		0x18,0x17,0x40,0xc0,0x84,0x60,0x00,0x00};

	char	i;
	char	data;

	for (i = 0; i < 8; i++) {		/* A chanel initialize	*/
		outp(P_SAC,i);			/* select register	*/
		data = id_sioa[i];
		outp(P_SAC,data);		/* output initial data	*/
		wr_sa[i] = data;		/* save port data	*/
	}

	for (i = 0; i < 8; i++) {		/* B chanel initialize	*/
		outp(P_SBC,i);			/* select register	*/
		data = id_siob[i];
		outp(P_SBC,data);		/* output initial data	*/
		wr_sb[i] = data;		/* save port data	*/
	}
}

/*	DTE line open	*/

topen()
{
	static	char	speed[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

	dipsw = inp(P_PAD);			/* read dip switch	*/

	outp(P_C0C,0x45);
	outp(P_C0C,speed[dipsw & 0x07]);	/* set DTE speed	*/

	wr_sb[4] &= ~0x0c;
	switch (dipsw & 0x18) {
	case 0x18:
		wr_sb[4] |= 0x04;
		break;
	case 0x10:
		wr_sb[4] |= 0x08;
		break;
	default:
		wr_sb[4] |= 0x0c;
		break;
	}
	outp(P_SBC,4);
	outp(P_SBC,wr_sb[4]);			/* set stop bit length	*/

	outp(P_SBC,0x03);
	wr_sb[3] |= (char)0x01;			/* receive enable	*/
	outp(P_SBC,wr_sb[3]);

	outp(P_SBC,0x05);
	wr_sb[5] |= (char)0x82;			/* DTR RTS on		*/
	outp(P_SBC,wr_sb[5]);
}

/*	DCE line conxxxt	*/

md_opn()
{
	static	char	d_crn[] = "\x02CRN";
	static	char	cbuff[28];
	char	*cbufp, *p;
	char	rr0, c;
	void	csend(), md_cls();
	int	strlen();
	int	strncmp();
	int	len;

	di();

	outp(P_SAC,4);
	wr_sa[4] |= 0x01;			/* parity enable	*/
	outp(P_SAC,wr_sa[4]);

	outp(P_SAC,5);
	wr_sa[5] &= ~0x40;
	wr_sa[5] |= 0x20;			/* send chr length = 7	*/
	outp(P_SAC,wr_sa[5]);

	outp(P_SAC,6);
	outp(P_SAC,0x16);			/* set SYN code		*/
	outp(P_SAC,7);
	outp(P_SAC,0x16);

	syn_code = 0x16;			/* third SYN code	*/

	outp(P_SAC,3);
	wr_sa[3] &= ~0x80;
	wr_sa[3] |= (char)0x51;			/* receive enable	*/
	outp(P_SAC,wr_sa[3]);

	outp(P_SAC,5);
	wr_sa[5] |= (char)0x80;			/* DTR on		*/
	outp(P_SAC,wr_sa[5]);
	ei();

	if (cmdbuf[1] != 0) {
		timer0 = 300;
		while (1) {
			if (rr_sa & 0x20)
				break;
			if (timer0 == 0) {
				md_cls();
				return(R_CCSTO);
			}
		}

		cbufp = cbuff;
		for (p = d_crn; *p; )
			*cbufp++ = *p++;
		for (p = &cmdbuf[1]; *p; )
			*cbufp++ = *p++;
		*cbufp++ = 0x03;
		*cbufp = 0;

		len = strlen(cbuff);
		csend(cbuff,(char)0,len); /* send CRN command 	*/

		timer0 = 6000;
		cbufp = cbuff;
		while (1) {
			if (timer0 == 0) {
				md_cls();
				return(R_CCOFTO);
			}
			if ((rr_sa & 0x20) == 0)
				break;
			if (rdlen1 != 0) {
				di();
				c = rbuff1[rrptr1++] & 0x7f;
				--rdlen1;
				if (rrptr1 == RBUFSIZ1)
					rrptr1 = 0;
				ei();
				*cbufp++ = c;
				if (c == 0x03) {
					if (strncmp(&cbuff[1],"VAL",3) == 0) {
						cbufp = cbuff;
					}
					else {
						md_cls();
						return(R_CIND);
					}
				}
			}
		}	
	}
	timer0 = 300;
	while (1) {
		if (rr_sa & 0x08)
			break;
		if (timer0 == 0) {
			md_cls();
			return(R_CDRTO);
		}
	}

	di();

	outp(P_SAC,3);
	wr_sa[3] |= 0xc0;			/* rev chr length = 8	*/
	outp(P_SAC,wr_sa[3]);

	outp(P_SAC,4);
	wr_sa[4] &= ~0x01;			/* parity disable	*/
	outp(P_SAC,wr_sa[4]);

	outp(P_SAC,5);
	wr_sa[5] |= 0x60;			/* send chr lenhth = 8	*/
	outp(P_SAC,wr_sa[5]);

	outp(P_SAC,6);
	outp(P_SAC,C_SYN);			/* set SYN code		*/
	outp(P_SAC,7);
	outp(P_SAC,C_SYN);

	syn_code = C_SYN;			/* third SYN code	*/

	ei();
	
	return(R_NORMAL);
}
	
strlen(p)
char	*p;
{
int	len;

	for(len = 0 ; *p++ != 0 ; len++)
		;
	return(len);
}

/*	DCE line md_clsxxxt	*/

md_cls()
{
	while (sdcount1 != 0) {}

/* 88.03.03 (aizawa) */
	timer0 = 10;				/* set 100 ms */
	while (timer0 != 0) {}			/* wait guard time */

	di();
	outp(P_SAC,3);
	wr_sa[3] &= (char)~0x01;		/* receive disable	*/
	outp(P_SAC,wr_sa[3]);

	outp(P_SAC,5);
	wr_sa[5] &= (char)~0x80;		/* DTR off		*/
	outp(P_SAC,wr_sa[5]);
	ei();
}

/*	DTE send	*/

tsend(sdp,sdlen)
char	*sdp;
int	sdlen;
{
	while (sd_flag2 != 0) {}

	if (sdlen == 0)
		return;

	di();

	sdptr2 = sdp;			/* save send data pointer	*/

	sd_flag2 = 1;			/* data sending flag set	*/

	sdcount2 = sdlen;		/* set data send flag		*/

	outp(P_SBC,0x05);
	wr_sb[5] |= (char)0x08;		/* transmitter enable		*/
	outp(P_SBC,wr_sb[5]);

	outp(P_SBD,*sdptr2++);		/* data send		*/
	sdcount2--;
	ei();
}

/*	send receive data	*/

sndrdt(dtp,sdlen)
char	*dtp;
int	sdlen;
{
static	char	sbuff[260];
	char	*p, etoj();
	int	length;

	p = sbuff;
	*p++ = 'X';			/* ETX block		*/
	*p++ = (char)sdlen;		/* data length set	*/
	length = sdlen;
	for ( ; length != 0 ; length--)
		*p++ = etoj(*dtp++);

	tsend(sbuff,sdlen+2);		/* EXT flag + length + data	*/
}

/*	DCE send	*/

csend(sdp,crc,sdlen)
char	*sdp, crc;
int	sdlen;
{
/*
	while (sd_flag1 != 0) {}
*/
	if (sdlen == 0)
		return;

	di();

	sdptr1 = sdtp = sdp;		/* save send data pointer	*/
	crcflg = crcf = crc;		/* save CRC send flag		*/
	sdr_lng = sdlen;		/* save send retry length	*/

	sdcount1 = sdlen;

	outp(P_SAC,5);
	wr_sa[5] |= 0x02;		/* RTS on			*/
	outp(P_SAC,wr_sa[5]);
	ei();

	timer0 = 300;
	while ((rr_sa & 0x20) == 0) {
		if (timer0 == 0) {
			di();
			outp(P_SAC,5);
			wr_sa[5] &= ~0x02;	/* RTS off		*/
			outp(P_SAC,wr_sa[5]);
			ei();
			return;
		}
	}

	di();
	outp(P_SAC,0x05);
	wr_sa[5] |= 0x08;		/* transmitter enable		*/
	outp(P_SAC,wr_sa[5]);

	outp(P_SAD,syn_code);		/* send sync code		*/
	ei();
}

/*	send data to modem	*/

sndmdm(sdp,sdlen)
char	*sdp;
int	sdlen;
{
	while ((inp(P_PBD) & 0x02) == 0) {}	/* wait CD off		*/

	csend(sdp,(char)0,sdlen);
}

/*	send data to modem (CRC)	*/

sndmdc(sdp,sdlen)
char	*sdp;
int	sdlen;
{
	while ((inp(P_PBD) & 0x02) == 0) {}	/* wait CD off		*/

	csend(sdp,(char)1,sdlen+4);		/* data + stx + etx + crc1,2 */
}

/*	retry send data		*/

sndrty()
{
	csend(sdtp,crcf,sdr_lng);
}

/*	timer set	*/

timst1(tmvalue)
int	tmvalue;
{
	if (tmvalue == -1)
		timer1 = tmvalue;
	else
		timer1 = tmvalue * 100;
}

/*	send responce	*/

sndrsp(rspcd)
int	rspcd;
{
static	char	table[] = "0123456789ABCDEF";
static	char	rspbuf[10];
	int	i, sdlen;
	char	*rsp;

	if (cmdflg == 0)
		return;

	rsp = rspbuf;

	if (rspcd == 0)
	{
		*rsp++ = 'N';
		sdlen = 2;
	}
	else
	{
		*rsp++ = 'E';
		for (i = 0x1000 ; i != 0x00 ; i /= 0x10) {
			*rsp++ = table[ rspcd / i ];
			rspcd %= i;
		}
		sdlen = 6;
	}
	*rsp++ = 0x0d;
	tsend(rspbuf,sdlen);
	cmdflg = 0;
}

/*	jis code -> ebcdic code	*/

char
jtoe(jiscode)
char	jiscode;
{
	static	char	jetbl[] = {
		0x00,0x01,0x02,0x03,0x37,0x2d,0x2e,0x2f,	/* 00	*/
		0x16,0x05,0x15,0x0b,0x0c,0x0d,0x0e,0x0f,
		0x10,0x11,0x12,0x13,0x3c,0x3d,0x32,0x26,	/* 01	*/
		0x18,0x19,0x3f,0x27,0x1c,0x1d,0x1e,0x1f,
		0x40,0x4f,0x7f,0x7b,0xe0,0x6c,0x50,0x7d,	/* 02	*/
		0x4d,0x5d,0x5c,0x4e,0x6b,0x60,0x4b,0x61,
		0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,	/* 03	*/
		0xf8,0xf9,0x7a,0x5e,0x4c,0x7e,0x6e,0x6f,
		0x7c,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,	/* 04	*/
		0xc8,0xc9,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,
		0xd7,0xd8,0xd9,0xe2,0xe3,0xe4,0xe5,0xe6,	/* 05	*/
		0xe7,0xe8,0xe9,0x4a,0x5b,0x5a,0x5f,0x6d,
		0x79,0x57,0x59,0x62,0x63,0x64,0x65,0x66,	/* 06	*/
		0x67,0x68,0x69,0x70,0x71,0x72,0x73,0x74,
		0x75,0x76,0x77,0x78,0x80,0x8b,0x9b,0x9c,	/* 07	*/
		0xa0,0xab,0xb0,0xc0,0x6a,0xd0,0xa1,0x07,
		0x20,0x21,0x22,0x23,0x24,0x25,0x06,0x17,	/* 08	*/
		0x28,0x29,0x2a,0x2b,0x2c,0x09,0x0a,0x1b,
		0x30,0x31,0x1a,0x33,0x34,0x35,0x36,0x08,	/* 09	*/
		0x38,0x39,0x3a,0x3b,0x04,0x14,0x3e,0xe1,
		0xb1,0x41,0x42,0x43,0x44,0x45,0x46,0x47,	/* 10	*/
		0x48,0x49,0x51,0x52,0x53,0x54,0x55,0x56,
		0x58,0x81,0x82,0x83,0x84,0x85,0x86,0x87,	/* 11	*/
		0x88,0x89,0x8a,0x8c,0x8d,0x8e,0x8f,0x90,
		0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,	/* 12	*/
		0x99,0x9a,0x9d,0x9e,0x9f,0xa2,0xa3,0xa4,
		0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xac,0xad,	/* 13	*/
		0xae,0xaf,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,
		0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,	/* 14	*/
		0xca,0xcb,0xcc,0xcd,0xce,0xcf,0xda,0xdb,
		0xdc,0xdd,0xde,0xdf,0xea,0xeb,0xec,0xed,	/* 15	*/
		0xee,0xef,0xfa,0xfb,0xfc,0xfd,0xfe,0xff
	};
	return(jetbl[jiscode]);
}

/*	ebcdic code -> jis code	*/

char
etoj(ebccode)
char	ebccode;
{
	static	char	ejtbl[] = {
		0x00,0x01,0x02,0x03,0x9c,0x09,0x86,0x7f,	/* 00	*/
		0x97,0x8d,0x8e,0x0b,0x0c,0x0d,0x0e,0x0f,
		0x10,0x11,0x12,0x13,0x9d,0x0a,0x08,0x87,	/* 01	*/
		0x18,0x19,0x92,0x8f,0x1c,0x1d,0x1e,0x1f,
		0x80,0x81,0x82,0x83,0x84,0x85,0x17,0x1b,	/* 02	*/
		0x88,0x89,0x8a,0x8b,0x8c,0x05,0x06,0x07,
		0x90,0x91,0x16,0x93,0x94,0x95,0x96,0x04,	/* 03	*/
		0x98,0x99,0x9a,0x9b,0x14,0x15,0x9e,0x1a,
		0x20,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,	/* 04	*/
		0xa8,0xa9,0x5b,0x2e,0x3c,0x28,0x2b,0x21,
		0x26,0xaa,0xab,0xac,0xad,0xae,0xaf,0x61,	/* 05	*/
		0xb0,0x62,0x5d,0x5c,0x2a,0x29,0x3b,0x5e,
		0x2d,0x2f,0x63,0x64,0x65,0x66,0x67,0x68,	/* 06	*/
		0x69,0x6a,0x7c,0x2c,0x25,0x5f,0x3e,0x3f,
		0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,	/* 07	*/
		0x73,0x60,0x3a,0x23,0x40,0x27,0x3d,0x22,
		0x74,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,	/* 08	*/
		0xb8,0xb9,0xba,0x75,0xbb,0xbc,0xbd,0xbe,
		0xbf,0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,	/* 09	*/
		0xc7,0xc8,0xc9,0x76,0x77,0xca,0xcb,0xcc,
		0x78,0x7e,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,	/* 10	*/
		0xd3,0xd4,0xd5,0x79,0xd6,0xd7,0xd8,0xd9,
		0x7a,0xa0,0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,	/* 11	*/
		0xe6,0xe7,0xda,0xdb,0xdc,0xdd,0xde,0xdf,
		0x7b,0x41,0x42,0x43,0x44,0x45,0x46,0x47,	/* 12	*/
		0x48,0x49,0xe8,0xe9,0xea,0xeb,0xec,0xed,
		0x7d,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,	/* 13	*/
		0x51,0x52,0xee,0xef,0xf0,0xf1,0xf2,0xf3,
		0x24,0x9f,0x53,0x54,0x55,0x56,0x57,0x58,	/* 14	*/
		0x59,0x5a,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,
		0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,	/* 15	*/
		0x38,0x39,0xfa,0xfb,0xfc,0xfd,0xfe,0xff
	};
	return(ejtbl[ebccode]);
}
